package generic;

/**
 * Generic response class.
 */
public class Status<T,E> {
	/** Indicate if the operation was a success. By default, <code>false</code>. */
	public boolean success;
	/** Response message.*/
	public String message;
	/** Response payload.*/
	public T payload;
	/** Response error */
	public E error;
	
	public Status() {
		super();
		this.success=false;
	}
	public Status(boolean success) {
		super();
		this.success = success;
	}
	public Status(boolean success, String message) {
		super();
		this.success = success;
		this.message = message;
	}
	public Status(boolean success, String message, T payload) {
		super();
		this.success = success;
		this.message = message;
		this.payload = payload;
	}
	public Status(boolean success, String message, T payload, E error) {
		super();
		this.success = success;
		this.message = message;
		this.payload = payload;
		this.error = error;
	}
	@Override
	public String toString() {
		String result="Status [success="+success+", message="+message;
		if(payload!=null) {
			result+=", payload="+payload.toString();
		}
		if(error!=null) {
			result+=", error="+error.toString();
		}
		return result+"]";
	}
}