package gui.panel;

import java.awt.GridBagConstraints;
import java.awt.event.KeyEvent;
import java.util.Locale;
import java.util.ResourceBundle;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JTextField;

import gui.GUI;

/**
 * <p>Handle the communication with the server</p>
 * <p>Allow the user to input and send commands and display their results.</p>
 */
public class CommunicationPanel extends LogPanel {
	private static final long serialVersionUID = 1L;
	private JLabel commandLabel;
	private JTextField commandText;
	private JButton executeButton;
		
	private GUI gui;
	
	public CommunicationPanel(GUI gui) {
		super();
		this.gui=gui;
		initialize();
	}

	@Override
	protected void initialize() {
		super.initialize();
		//GridBagLayout gbl_main=new GridBagLayout();
		//this.setLayout(gbl_main);
		
		commandLabel=new JLabel("labelCommand");
		GridBagConstraints gbc_commandLabel=new GridBagConstraints();
		gbc_commandLabel.gridx=0;
		gbc_commandLabel.gridy=0;
		gbc_commandLabel.anchor=GridBagConstraints.WEST;
		this.add(commandLabel,gbc_commandLabel);
		
		commandText=new JTextField();
		commandText.addKeyListener(new java.awt.event.KeyAdapter() {
			@Override
			public void keyPressed(java.awt.event.KeyEvent e) {
				if(e.getKeyCode() == KeyEvent.VK_ENTER){
					executeButton.doClick();
				}
			}
		});
		GridBagConstraints gbc_commandText=new GridBagConstraints();
		gbc_commandText.gridx=0;
		gbc_commandText.gridy=1;
		gbc_commandText.weightx=1.0d;
		gbc_commandText.fill=GridBagConstraints.BOTH;
		this.add(commandText,gbc_commandText);
		
		executeButton=new JButton("executeButton");
		executeButton.addActionListener(new java.awt.event.ActionListener() {
			@Override
			public void actionPerformed(java.awt.event.ActionEvent e) {
				if(commandText.getText().isBlank()==false) {
					gui.sendCommand(commandText.getText());
				}
			}
		});
		GridBagConstraints gbc_executeButton=new GridBagConstraints();
		gbc_executeButton.gridx=3;
		gbc_executeButton.gridy=1;
		this.add(executeButton,gbc_executeButton);
		
		setText();
	}
	
	@Override
	public void setText() {
		super.setText();
		ResourceBundle resourceBundle=ResourceBundle.getBundle("bundle/Bundle",Locale.getDefault());
		commandLabel.setText(resourceBundle.getString("commandToExecute"));
		executeButton.setText(resourceBundle.getString("execute"));
	}
}