package main;

import java.util.Locale;
import java.util.ResourceBundle;

import gui.GUI;
import network.Server;
import thread.ServerThread;

public class Primary {

	public static void main(String[] args) {
		int port=6200;
		boolean showGUI=true;
		
		//Handle user arguments
		if(args.length>0){
    		for(int i=0;i<args.length;i++){
    			if(args[i].startsWith("port=")){
    				port=Integer.valueOf(args[i].substring(3));
    			}
    			if(args[i].startsWith("nogui")){
    				showGUI=false;
    			}
    			if(args[i].startsWith("help")||args[i].startsWith("?")){
    				ResourceBundle resourceBundle=ResourceBundle.getBundle("bundle/Bundle",Locale.getDefault());
    				System.out.println(resourceBundle.getString("help_intro")+"\n");
    				System.out.println(resourceBundle.getString("help_argument"));
    				System.out.println("port=X\t"+resourceBundle.getString("help_port"));
    				System.out.println("nogui\t"+resourceBundle.getString("help_nogui"));
    				System.out.println("help,?\t"+resourceBundle.getString("help_help"));
    				return;
    			}
    		}
		}
		Server server=new Server(port);
		ServerThread serverThread=new ServerThread(server);
		
		if(showGUI) {
			GUI gui=new GUI(serverThread);
			gui.show();
			serverThread.setGui(gui);
		}
		
		serverThread.start();
	}

}
