package network;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.ArrayList;
import java.util.List;

import generic.Status;
/**
 * TCP server allowing to send and receive Objects.
 */
public class Server {
	private int serverPort;
	private ServerSocket serverSocket;
	private List<Socket> clientSocket;
	
	public Server(int serverPort) {
		super();
		this.serverPort = serverPort;
		clientSocket=new ArrayList<Socket>();
	}

	public Status<Integer,IOException> start() {
		Status<Integer,IOException> result=new Status<Integer,IOException>(true);
		try {
			serverSocket=new ServerSocket(serverPort);
			result.payload=serverSocket.getLocalPort();
		} catch (IOException e) {
			result.success=false;
			result.error=e;
		};
		return result;
	}
	
	public Status<Socket,IOException> accept() {
		Status<Socket,IOException> result=new Status<Socket,IOException>(true);
		try {
			Socket client=serverSocket.accept();
			clientSocket.add(client);
			result.payload=client;
		} catch (IOException e) {
			result.success=false;
			result.error=e;
		};
		return result;
	}
	
	public void stop() {
		try {
			serverSocket.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}